--[[

	This library was written by 
		Janniie - Stormreaver EU
	
	For use in the AddOn SuperGuildInvite(SGI) 
	
	Feel free to use it as you wish, with the condition to 
	credit the original author.
	
	
	InfoShare is used to share information between users
	
]]

Info_Share_Lib = {}

local infoShare_Busy = false
local playerQueue = {}

local ID_PREFIX1 = "INFO_SHARE1"
local ID_PREFIX2 = "INFO_SHARE2"
RegisterAddonMessagePrefix(ID_PREFIX1)
RegisterAddonMessagePrefix(ID_PREFIX2)

local ID_REQUEST = "REQUEST"
local ID_ITEM = "ITEM"
local ID_STOP = "STOP"
local ID_START = "START"
local ID_BUSY = "BUSY"
local ID_ANSWER = "ANSWER"
local ID_CLEAR = "CLEAR"
local ID_FINNISHED = "FINNISHED"


local QueueTimer = CreateFrame("Frame")
local GetTime = GetTime
local Transfer = {}
local Transfered = {}
local t_Index = 0

local Table = {}
local index1,index2,index3 = 0,1,1
local ref = 0
local Target = ""

local function SendRequest(target)
	if target then
		SendAddonMessage(ID_PREFIX1,ID_REQUEST,"WHISPER",target)
	else
		SendAddonMessage(ID_PREFIX1,ID_REQUEST,"GUILD")
	end
end

local function SetSource(source)
	Table = source
end

local function SetPrefix(prefix)
	ID_PREFIX1 = prefix.."1"
	ID_PREFIX2 = prefix.."2"
	RegisterAddonMessagePrefix(ID_PREFIX1)
	RegisterAddonMessagePrefix(ID_PREFIX2)
end

local function AnswerRequest(sender)
	SendAddonMessage(ID_PREFIX1,ID_ANSWER,"WHISPER",sender)
end

local function GiveClearance(target)
	SendAddonMessage(ID_PREFIX1,ID_CLEAR,"WHISPER",target)
end

local function GetClearance()
	return not infoShare_Busy
end

local function strdiv(str,sep)
	local OUT,index = {},0
	while strfind(str,sep) do
		index = index + 1
		OUT[index] = strsub(str,1,strfind(str,sep)-1)
		str = strsub(str,strfind(str,sep)+1)
	end
	return OUT
end

local function CheckQueue()
	if not insfoShare_Busy then
		local _,V = next(playerQueue)
		StartTransfer(Table,sender,true)
		if #playerQueue == 0 then
			QueueTimer:SetScript("OnUpdate",nil)
		end
	end
end

local function BusyAndQueue(target)
	SendAddonMessage(ID_PREFIX,ID_BUSY,"WHISPER",target)
	tinsert(playerQueue,target)
	QueueTimer:SetScript("OnUpdate",CheckQueue)
end


local function TransferOnUpdate(self)
	if ( GetTime() - ref >= 2 ) then
		SendAddonMessage(ID_PREFIX2,Transfer[index2],"WHISPER",Target)
		ref = GetTime()
		index2 = index2 + 1
		if ( not Transfer[index2 + 1] ) then
			self:SetScript("OnUpdate",nil)
			infoShare_Busy = false
			SendAddonMessage(ID_PREFIX1,ID_FINNISHED,"WHISPER",Target)
		end
	end
end

local function StartTransfer(Table,target)
	Transfer = {}
	index1,index2,index3 = 1,1,1
	ref = 0
	
	for k,_ in pairs( Table ) do
		Transfer[index1] = ( Transfer[index1] or "" )..k..";"
		if strlen(Transfer[index1]) > 200 then
			index1 = index1 + 1
		end
	end
	Target = target
	
	local f = CreateFrame("Frame")
	f:SetScript("OnUpdate",TransferOnUpdate)
	infoShare_Busy = true
end





local function OnRequest(msg,sender)
	if ( msg == ID_REQUEST ) then
		if GetClearance() then
			AnswerRequest(sender)
		else
			BusyAndQueue(sender)
		end
	elseif ( msg == ID_BUSY ) then
		print("|cffFF8800"..sender.."|r|cff88AAFF is busy and will contact you soon.|r")
	elseif ( msg == ID_ANSWER ) then
		GiveClearance(sender)
	elseif ( msg == ID_CLEAR ) then
		StartTransfer(Table,sender)
	end
end

local function OnRecievedData(msg,sender)
	t_Index = t_Index + 1
	local t = strdiv(msg,";")
	for k,_ in pairs( t ) do
		Transfered[t_Index] = t[k]
	end
end

local function GetData()
	return Transfered
end

local function OnRecievedMessage(self,event,...)
	local prefix,msg,channel,sender = select(1,...)
	if UnitName("player") ~= sender then
		if prefix == ID_PREFIX1 then
			OnRequest(msg,sender)
		elseif prefix == ID_PREFIX2 then
			OnRecievedData(msg,sender)
		end
	end
end

local MsgFrame = CreateFrame("Frame")
MsgFrame:RegisterEvent("CHAT_MSG_ADDON")
MsgFrame:SetScript("OnEvent",OnRecievedMessage)

Info_Share_Lib.SendRequest  = SendRequest
Info_Share_Lib.GetData 	    = GetData
Info_Share_Lib.SetPrefix	= SetPrefix
Info_Share_Lib.SetSource	= SetSource